const HourTextSize = 14;
const MinTextSize = 14;
const SecTextSize = 14;

var InRefreshTrains = false;
var InHourChange = 2;
var InMinChange = 2;
var Hour = -1;
var Min = -1;
var SecAnimation = null;
var HourTrain = null;
var MinTrain = null;
var SecTrain = null;
var SecOffset = 0;

//var BackImage;

//var BackImageFiles = new Array();
//var BackImageNum = -1;
var HourImageFiles = new Array();
var HourImageNum = -1;
var MinImageFiles = new Array();
var MinImageNum = -1;
var SecImageFiles = new Array();
var SecImageNum = 0;

var HourSoundFiles = new Array();
var HourSoundNum = -1;

//-------------------------------
// Train class
function Train(win, textsize, basezorder) {
	this.width = 0;
	this.height = 0;
	this.win = win;
	this.textsize = textsize;
	this.basezorder = basezorder;
	this.frame = new Frame(win);
	this.images = new Array();
	this.shadowtext = new Text(win);
	this.text = new Text(win);
	this.frame.addSubview(this.shadowtext);
	this.frame.addSubview(this.text);
	with(this.frame) {
		hAlign = "left";
		hOffset = 0;
		vAlign = "bottom";
		zOrder = basezorder;
	}
	with(this.shadowtext) {
		size = textsize;
		color = "#000000";
		opacity = 0;
		hAlign = "center";
		zOrder = basezorder + 2;
	}
	with(this.text) {
		size = textsize;
		color = "#FFFFFF";
		opacity = 0;
		hAlign = "center";
		zOrder = basezorder + 3;
	}
	
}

Train.prototype.setImage = function (imglist) {
	if( imglist == null ) {
		for( var j = 0; j < this.images.length; j++ ) {
			this.images[j].src = "";
		}
		return;
	}
	this.images.length = imglist.list.length;
	this.frame.width = 0;
	this.frame.height = 0;
	this.dir = imglist.dir;
	for( var j = 0; j < imglist.list.length; j++ ) {
		var file = imglist.list[j];
		if( file.push ) {
			var num = Math.floor(Math.random() * file.length);
			file = file[num];
		}
		//print(file + "\r");
		if( !this.images[j] ) {
			var image = new Image(this.win);
			this.frame.addSubview(image);
			image.hAlign = "left";
			image.vAlign = "bottom";
			image.zOrder = this.basezorder + 1;
			this.images[j] = image;
		}
		var image = this.images[j];
		image.src = file;
		image.hOffset = this.frame.width;
		this.frame.width += image.width;
		this.frame.height = Math.max(this.frame.height, image.height);
	}
	for( var j = 0; j < this.images.length; j++ ) {
		this.images[j].vOffset = this.frame.height;
	}
	this.width = this.frame.width;
	this.height = this.frame.height;
	this.shadowtext.hOffset = this.width / 2 + 1;
	this.text.hOffset = this.width / 2;
	this.shadowtext.vOffset = this.height / 2 + this.textsize / 2 + 1;
	this.text.vOffset = this.height / 2 + this.textsize / 2;
};

Train.prototype.setHOffset = function (offset) {
	this.frame.hOffset = offset;
}

Train.prototype.setVOffset = function (offset) {
	this.frame.vOffset = offset;
}

Train.prototype.setText = function (text) {
	this.shadowtext.data = text;
	this.text.data = text;
};

Train.prototype.setTextOpacity = function (opacity) {
	this.shadowtext.opacity = opacity;
	this.text.opacity = opacity;
}

//-------------------------------
function ImageList(dir) {
	this.dir = dir;
	this.list = new Array();
}

ImageList.prototype.push = function (obj) {
	this.list.push(obj);
}

//-------------------------------

function substmacro(str, macro) {
	var subst = false;
	while( str.match(/%([0-9A-Za-z_]+)/) ) {
		var mname = RegExp.$1;
		var mvalue = macro[mname];
		str = RegExp.leftContext + mvalue + RegExp.rightContext;
		subst = true;
	}
	return str;
}

function Initialize() {
	//suppressUpdates();
	
	MainWindow.width = screen.availWidth;
	MainWindow.alignment = "left";
	MainWindow.hOffset = 0;
	
	//BackImage = new Image(MainWindow);
	
	HourTrain = new Train(MainWindow, HourTextSize, 10);
	MinTrain = new Train(MainWindow, MinTextSize, 20);
	SecTrain = new Train(MainWindow, SecTextSize, 30);
	
	// Read formation.txt and set *ImageFiles and HourSoundFiles array
	var imgdir;
	var sounddir;
	var widgetdir = system.userWidgetsFolder;
	if( filesystem.itemExists(widgetdir + "/TrainClock") &&
		filesystem.itemExists(widgetdir + "/TrainClock/formation.txt") ) {
		imgdir = widgetdir + "/TrainClock";
		sounddir = widgetdir + "/TrainClock";
	} else {
		imgdir = "Resources/Images";
		sounddir = "Resources/Sounds";
	}
	var lines = filesystem.readFile(imgdir + "/formation.txt", true);
	var macro = new Array();
	for( var j = 0; j < lines.length; j++ ) {
		var line = lines[j];
		line = line.replace(/\s+/g, "");
		if( line.match(/^%([0-9A-Za-z_]+)=(.+)/) ) {
			var mname = RegExp.$1;
			var mvalue = RegExp.$2;
			macro[mname] = mvalue;
		} else if( line.match(/^([HMS])([0-9]*)([<>]?)=(.+)/) ) {
			var hm = RegExp.$1;
			var num = RegExp.$2;
			var dir = RegExp.$3;
			var filespec = RegExp.$4;
			filespec = substmacro(filespec, macro);
			var tmp = filespec.split('+');
			//var list = new Array();
			var list = new ImageList(dir);
			for( var k = 0; k < tmp.length; k++ ) {
				var file = tmp[k];
				if( file.match(/\*([0-9]+)$/) ) {
					var repeat = RegExp.$1;
					file = file.replace(/\*[0-9]+$/, "");
					tmp.splice(k, 1);
					for( var m = 0; m < repeat; m++ ) {
						tmp.splice(k, 0, file);
					}
					//print(tmp.toString()+"\r");
				}
				var elm;
				if( file.match(/^\{(.+)\}$/) ) {
					elm = new Array();
					var tmp2 = RegExp.$1.split('|');
					for( var m = 0; m < tmp2.length; m++ ) {
						var path = imgdir + "/" + tmp2[m] + ".png";
						if( filesystem.itemExists(path) ) {
							elm.push(path);
						} else {
							alert(path + "Ȃ");
						}
					}
					if( elm.length > 0 ) {
						list.push(elm);
					}
				} else {
					elm = imgdir + "/" + file + ".png";
					if( filesystem.itemExists(elm) ) {
						list.push(elm);
					} else {
						alert(elm + "Ȃ");
					}
				}
			}
			if( list.list.length > 0 ) {
				if( num == "" ) {
					if( hm == "H" ) { HourImageFiles.push(list); }
					else if( hm == "M" ) { MinImageFiles.push(list); }
					else if( hm == "S" ) { SecImageFiles.push(list); }
				} else {
					if( hm == "H" ) { HourImageFiles[num] = list; }
					else if( hm == "M" ) { MinImageFiles[num] = list; }
					else if( hm == "S" ) { SecImageFiles[num] = list; }
				}
			} 
		} else if( line.match(/^HS=(.+)/) ) {
			var filespec = RegExp.$1;
			var path = sounddir + "/" + filespec + ".wav";
			if( filesystem.itemExists(path) ) {
				HourSoundFiles.push(path);
			} else {
				alert(path + "Ȃ");
			}
		}
	}
	if( SecImageFiles.length == 0 ) {
		SecImageFiles = MinImageFiles;
	}
	if( HourSoundFiles.length == 0 ) {
		HourSoundFiles.push("Resources/Sounds/hour.wav");
	}
	HourSoundNum = 0;
	
//	if( preferences.randommin.value == 1 ) {
//		var work = new Array();
//		for( j = MinImageFiles.length; j > 0; j-- ) {
//			var k = Math.floor(Math.random() * j);
//			work.push(MinImageFiles.splice(k, 1));
//		}
//		MinImageFiles = work;
//	}

//print(HourImageFiles.toString() + "\r");
//print(MinImageFiles.toString() + "\r");
//print(SecImageFiles.toString() + "\r");
//print(BackImageFiles.toString() + "\r");
	
//	with(BackImage) {
//		src = BackImageFiles[0];
//		hAlign = "left";
//		hOffset = MainWindow.width;
//		vAlign = "bottom";
//	}
	
//print(HourImageFiles[0].toString() + "\r");
//print(MinImageFiles[0].toString() + "\r");
//print(SecImageFiles[0].toString() + "\r");
	HourTrain.setImage(HourImageFiles[0]);
	MinTrain.setImage(MinImageFiles[0]);
	SecTrain.setImage(SecImageFiles[0]);

	var secoffset = eval(preferences.secoffset.value);
	SecOffset = secoffset;

	MainWindow.height = Math.max(HourTrain.height, 
		Math.max(MinTrain.height, SecTrain.height));
	MainWindow.height += secoffset;
//	BackImage.vOffset = MainWindow.height;
	HourTrain.setVOffset(MainWindow.height - secoffset);
	MinTrain.setVOffset(MainWindow.height - secoffset);
	SecTrain.setVOffset(MainWindow.height);

	HourTrain.setImage(null);
	MinTrain.setImage(null);
	SecTrain.setImage(null);
	
	resumeUpdates();
	
	refreshTrains();
	
	refreshtimer.ticking = true;
}

function OnUnLoad() {
}

function setHourTrainText() {
	var h = preferences.hour24.value == 1 ? Hour : Hour % 12;
	HourTrain.setText(h);
}

function setHourTrainImageAndText() {
	setHourTrainText();
	HourTrain.setImage(HourImageFiles[HourImageNum]);
}

function setMinTrainText() {
	var h = preferences.hour24.value == 1 ? Hour : Hour % 12;
	var hm;
	if( preferences.disphour.value == "no" ) {
		hm = Min < 10 ? h + ":0" + Min : h + ":" + Min;
	} else {
		hm = Min < 10 ? "0" + Min : Min;
	}
	MinTrain.setText(hm);
}

function setMinTrainImageAndText() {
	setMinTrainText();
	MinTrain.setImage(MinImageFiles[MinImageNum]);
}

function pushMoveAnim(hm, anims, obj, newhoff, speed, ease, onend) {
	newhoff = Math.floor(newhoff);
	if( newhoff != obj.hOffset ) {
		//print(hm + ":" + obj.hOffset + " -> " + newhoff + " (" + speed + ")\r");
		var anim = onend ?
			new MoveAnimation(obj, newhoff, obj.vOffset,
				Math.abs(newhoff - obj.hOffset) / 
				MainWindow.width * speed * 1000,
				ease, onend) :
			new MoveAnimation(obj, newhoff, obj.vOffset,
				Math.abs(newhoff - obj.hOffset) / 
				MainWindow.width * speed * 1000,
				ease);
		anims.push(anim);
	}
}

function refreshSec() {
	if( preferences.dispsectrain.value == 0 ) {
		return;
	}
	suppressUpdates();
	if( SecAnimation != null ) {
		SecAnimation.kill();
	}
	if( preferences.randomsec.value == 1 ) {
		SecImageNum = Math.floor(Math.random() * SecImageFiles.length);
	} else {
		SecImageNum = (SecImageNum + 1) % SecImageFiles.length;
	}
	SecTrain.setImage(SecImageFiles[SecImageNum]);
	var starthoff = - SecTrain.width;
	var endhoff = MainWindow.width;
	if( SecImageFiles[SecImageNum].dir == "<" ) {
		starthoff = MainWindow.width;
		endhoff = - SecTrain.width;
	}
	SecTrain.setHOffset(starthoff);
	resumeUpdates();
	
	SecAnimation = new MoveAnimation(SecTrain.frame, 
		endhoff, 
		SecTrain.frame.vOffset, 60000, animator.kEaseNone);
	animator.start(SecAnimation);
}

function onHourOuted() {
	InHourChange = 2;
//print("Hour Outed\r");
}

function onMinOuted() {
	InMinChange = 2;
//print("Min Outed\r");
}

function onHourInned() {
	InHourChange = 0;
//print("Hour Inned\r");
}

function onMinInned() {
	InMinChange = 0;
//print("Min Inned\r");
}

function playHourSound() {
	//play("Resources/Sounds/hour.wav", false);
	play(HourSoundFiles[HourSoundNum], false);
	if( --this.times ) {
		return true;
	} else {
		return false;
	}
}

function startHourSound(hour) {
	HourSoundNum = hour % HourSoundFiles.length;
	hour = hour % 12;
	if( hour == 0 ) {
		hour = 12;
	}
	var hs = new CustomAnimation(1000, playHourSound);
	hs.times = hour;
	animator.start(hs);
}

function refreshTrains() {
	if( InRefreshTrains ) {
		return;
	}
	InRefreshTrains = true;
	
	if( MainWindow.hOffset != 0 ) {
		MainWindow.hOffset = 0;
	}
	
	var now = new Date();
	var hour = now.getHours();
	var min = now.getMinutes();

	var hourchanged = false;
	var minchanged = false;

	if( Min != min ) {
		minchanged = true;
		var needsec = Min != -1;
		Min = min;
		if( needsec ) {
			refreshSec();
		}
	}

	if( Hour != hour ) {
		hourchanged = true;
		var needout = Hour != -1;
		Hour = hour;
		
		//print(Hour + ":" + Min + "\r");
		
		HourImageNum = Hour % HourImageFiles.length;
		if( preferences.randommin.value == 1 ) {
			MinImageNum = Math.floor(Math.random() * MinImageFiles.length);
		} else {
			MinImageNum = Hour % MinImageFiles.length;
		}
		//print(Hour + ":" + HourImageNum + "," + MinImageNum + "\r");
		
		if( needout ) {
			if( preferences.hoursound.value == 1 ) {
				startHourSound(Hour);
			}
			var anims = new Array();
			pushMoveAnim("H0", anims, HourTrain.frame, 
				MainWindow.width,
				10, animator.kEaseIn, onHourOuted);
			pushMoveAnim("M0", anims, MinTrain.frame, 
				MainWindow.width,
				10, animator.kEaseIn, onMinOuted);
			InHourChange = 3;
			InMinChange = 3;
			animator.start(anims);
		}
	}
	
	var hourmoveperiod = preferences.hourmoveperiod.value;
	var minmoveperiod = preferences.minmoveperiod.value;
	var disphour = preferences.disphour.value;
	var dispmin = preferences.dispmin.value;
	
	if( InHourChange == 2 ) {
		setHourTrainImageAndText();
		HourTrain.setHOffset(- HourTrain.width);
		var anims = new Array();
		var newhoff = hourmoveperiod == "min" ?
			MainWindow.width * (Hour * 60 + Min) / 1440 - HourTrain.width / 2 :
			MainWindow.width * Hour / 24 - HourTrain.width / 2;
		pushMoveAnim("H1", anims, HourTrain.frame, 
			newhoff,
			10, animator.kEaseOut, onHourInned);
		InHourChange = 1;
		animator.start(anims);
	}
	
	if( InMinChange == 2 ) {
		setMinTrainImageAndText();
		MinTrain.setHOffset(- MinTrain.width);
		var anims = new Array();
		var now = new Date();
		var sec = now.getSeconds();
		var newhoff = minmoveperiod == "sec" ?
			MainWindow.width * (Min * 60 + sec) / 3600 - MinTrain.width / 2 :
			MainWindow.width * Min / 60 - MinTrain.width / 2;
		pushMoveAnim("M1", anims, MinTrain.frame, 
			newhoff,
			10, animator.kEaseOut, onMinInned);
		InMinChange = 1;
		animator.start(anims);
	}
	
	var anims = new Array();
	
	if( InHourChange == 0 && hourmoveperiod == "min" && minchanged ) {
		pushMoveAnim("H2", anims, HourTrain.frame, 
			MainWindow.width * (Hour * 60 + Min) / 1440 - HourTrain.width / 2,
			20, animator.kEaseNone);
	}
	
	if( InMinChange == 0 ) {
		if( minmoveperiod == "min" && minchanged ) {
			pushMoveAnim("M21", anims, MinTrain.frame, 
				MainWindow.width * Min / 60 - MinTrain.width / 2,
				20, animator.kEaseInOut);
		} else if( minmoveperiod == "sec" ) {
			var now = new Date();
			var sec = now.getSeconds();
			pushMoveAnim("M22", anims, MinTrain.frame, 
				MainWindow.width * (Min * 60 + sec) / 3600 - MinTrain.width / 2,
				20, animator.kEaseNone);
		}
	}
	
	if( minchanged && dispmin != "no" ) {
		setMinTrainText();
		MinTrain.setTextOpacity(255);
		if( dispmin != "always" ) {
			anims.push(new FadeAnimation(MinTrain.shadowtext, 0, dispmin * 1000,
				animator.kEaseIn));
			anims.push(new FadeAnimation(MinTrain.text, 0, dispmin * 1000,
				animator.kEaseIn));
		}
	}
	if( minchanged && disphour != "no" ) {
		setHourTrainText();
		HourTrain.setTextOpacity(255);
		if( disphour != "always" ) {
			anims.push(new FadeAnimation(HourTrain.shadowtext, 0, 
				disphour * 1000, animator.kEaseIn));
			anims.push(new FadeAnimation(HourTrain.text, 0, 
				disphour * 1000, animator.kEaseIn));
		}
	}
	if( anims.length > 0 ) {
		animator.start(anims);
	}
	
	InRefreshTrains = false;
}

function updatePreferences() {
	var disphour = preferences.disphour.value;
	if( disphour == "no" ) {
		HourTrain.setTextOpacity(0);
	} else if( disphour == "always" ) {
		HourTrain.setTextOpacity(255);
	}
	var dispmin = preferences.dispmin.value;
	if( dispmin == "no" ) {
		MinTrain.setTextOpacity(0);
	} else if( dispmin == "always" ) {
		MinTrain.setTextOpacity(255);
	}
}

Initialize();
